#include <iostream>
#include <thread>
#include <mutex>

std::mutex mutex1, mutex2;

void task_a() {
    std::lock(mutex1, mutex2);
    std::cout << "Task A acquired both locks\n";
    mutex1.unlock();
    mutex2.unlock();
}

void task_b() {
    std::lock(mutex2, mutex1);  // Note the different order
    std::cout << "Task B acquired both locks\n";
    mutex2.unlock();
    mutex1.unlock();
}

int main() {
    std::thread t1(task_a);
    std::thread t2(task_b);
    t1.join();
    t2.join();
    return 0;
}
